SystemOrganization addCategory: #'Glamour-Seaside-Rendering'!

!String methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:27'!
cssDictionary

	"a string has no attributes"
	^ Dictionary new! !

!String methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:29'!
cssDictionaryAt: anIndex

	"a string has no attributes"
	^ Dictionary new! !

!String methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:59'!
cssDictionaryForFullText 

	"a string has no attributes"
	^ Dictionary new! !

!TextAlignment methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 12:21'!
cssPropertyAndValue

	| strm |
	self alignment = Centered ifTrue: [^ ('text-align' -> 'center') ].
	self alignment = Justified ifTrue: [^ ('text-align' -> 'justify') ].
	self alignment = LeftFlush ifTrue: [^ ('text-align' -> 'left')].
	self alignment = RightFlush ifTrue: [^ ('text-align' -> 'right')].
	^ (nil -> nil)! !

Announcement subclass: #SGLTextPresenterSelectedTextChanged
	instanceVariableNames: 'selectedText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTextPresenterSelectedTextChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/28/2010 02:06'!
selectedText
	^ selectedText! !

!SGLTextPresenterSelectedTextChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/28/2010 02:06'!
selectedText: anObject
	selectedText := anObject! !

Announcement subclass: #SGLTextPresenterSelectionIntervalChanged
	instanceVariableNames: 'selectionInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTextPresenterSelectionIntervalChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/28/2010 02:06'!
selectionInterval
	^ selectionInterval! !

!SGLTextPresenterSelectionIntervalChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/28/2010 02:06'!
selectionInterval: anObject
	selectionInterval := anObject! !

Announcement subclass: #SGLTextPresenterTextChanged
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTextPresenterTextChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 22:42'!
text
	^ text! !

!SGLTextPresenterTextChanged methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 22:42'!
text: anObject
	text := anObject! !

WAPresenter subclass: #SGLPresenter
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

SGLPresenter subclass: #SGLActionPresenter
	instanceVariableNames: 'presentation showAsIconCount actionsMap fullRendering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLActionPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/29/2010 21:26'!
actionScriptFor: anAction with: html
	^ html jQuery ajax
		script: [:script| 
			anAction actOn: presentation.
			self renderer updateScript: script ] ! !

!SGLActionPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/6/2011 12:54'!
fullRendering
	^ fullRendering! !

!SGLActionPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/6/2011 12:54'!
fullRendering: anObject
	fullRendering := anObject! !

!SGLActionPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/6/2011 14:06'!
initializeFor: aPresentation
	presentation := aPresentation.
	actionsMap := GRSmallDictionary new.
	self showAsIconCount: 2.
	self fullRendering: true! !

!SGLActionPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 9/1/2010 01:23'!
menuScriptWith: html
	^ html jQuery new buildMenu 
			menuWidth: 110;
			hasImages: false;
			closeOnMouseOut: true! !

!SGLActionPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/14/2010 00:22'!
renderAction: anAction on: html
	html image 
		form: anAction icon;
		id: html nextId;
		title: anAction title;
		onClick: ( self actionScriptFor: anAction with: html )! !

!SGLActionPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/31/2010 22:15'!
renderActions: actions on: html
	| headerIcons menuIcons count |
	count := 1.
	headerIcons := OrderedCollection new.
	menuIcons := OrderedCollection new.
	actions do: [:each|
		(each hasIcon and: [count <= self showAsIconCount])
			ifTrue: [
				headerIcons add: each. 
				count := count + 1] 
			ifFalse: [menuIcons add: each] ].
	headerIcons do: [:each|
		self renderAction: each on: html ].
	(menuIcons isEmpty) ifFalse: [
			self renderMenuForActions: actions on: html ]! !

!SGLActionPresenter methodsFor: 'rendering' stamp: 'AndreiChis 9/26/2010 14:58'!
renderContentOn: html
	|actions|
	actions := (presentation actions select: [:action | 
		action worksWithSeaside and: [
			action hasIcon or: [action hasTitle] ] ]) asOrderedCollection.
	html div
		class: 'glm-ac-container';
		with: [ self renderActions: actions on: html ]! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 8/8/2011 22:26'!
renderMbMenuActionOrCategory: anActionOrCategory withMenuId: anId on: html
	|anchor|
	anchor :=html anchor.
	anId ifNil: [
			anchor action: (self actionScriptFor: anActionOrCategory with: html) ]
		ifNotNil: [anchor menu: anId].
	anchor 	with: [
			"html image form: (actions at: index) icon."
			html text: (anId ifNil: [anActionOrCategory title] ifNotNil: [anActionOrCategory]) ]! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 9/1/2010 00:30'!
renderMbMenuCategories: categories on: html
	|id ids|
	ids := Dictionary new.
	categories keys do: [:each|
		id := html nextId.
		ids at: each put: id.
		self renderMbMenuActionOrCategory: each withMenuId: id on: html ].
	^ ids! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 9/1/2010 00:30'!
renderMbMenuContentForActions: actions on: html
	actions do: [ :each|
		self renderMbMenuActionOrCategory: each withMenuId: nil on: html ] ! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 8/6/2011 14:25'!
renderMbMenuForCachedActionsOn: html
	fullRendering ifFalse: [
			actionsMap keysAndValuesDo: [:id :actions|
				self renderMbMenuWithId: id forActions: actions on: html]]
		! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'tg 10/29/2010 23:38'!
renderMbMenuHeaderContentForMenu: aMenuId on: html
	html tableRow: [ 
		html tableData
			class: 'rootVoices';
			menu: aMenuId;
			with: [ 
				html image
					form: GLMUIThemeIcons windowMenuForm;
					class: 'glm-mbMenu-header-icon'
					"url: (SGLFileLibrary urlOf: #arrowDownPng)" ] ]! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 8/14/2010 00:22'!
renderMbMenuHeaderForMenu: aMenuId on:  html
	html div 
		id: html nextId;
		class: 'glm-ac-container-menu';
		script: (self menuScriptWith: html);
		with: [
			html table 
				class: 'rootVoices';
				cellpadding: 0; cellspacing: 0;
				border: 0;
				with: [
					self renderMbMenuHeaderContentForMenu: aMenuId on: html ] ]
! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 9/1/2010 00:30'!
renderMbMenuWithId: anId forActions: actions on: html
	|categories uncategorizedActions categoriesId|
	categories := Dictionary new.
	uncategorizedActions := OrderedCollection new.
	actions do: [:each|
		(each category) 
			ifNil: [uncategorizedActions add: each] 
			ifNotNil: [ 
				|category|
				category := categories at: each category ifAbsentPut: [OrderedCollection new].
				category add: each ] ].
	html div 
		class: 'mbmenu';
		id: anId;
		with: [ 
			self renderMbMenuContentForActions: uncategorizedActions on: html.
			categoriesId := self renderMbMenuCategories: categories on: html ].
	self renderMbSubmenuesFor: categories withIds: categoriesId on: html.! !

!SGLActionPresenter methodsFor: 'mbmenu' stamp: 'AndreiChis 9/1/2010 00:30'!
renderMbSubmenuesFor: categories withIds: ids on: html
	| category |
	categories keys do: [:each|
		 html div
			id: (ids at: each);
			class: 'mbmenu';
			with: [
				(categories at: each) do: [:action|
					self renderMbMenuActionOrCategory: action withMenuId: nil on: html ] ] ]
	! !

!SGLActionPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/6/2011 14:07'!
renderMenuForActions: actions on: html
	|id|
	id := html nextId.
	self renderMbMenuHeaderForMenu: id on:  html.
	fullRendering 
		ifTrue: [self renderMbMenuWithId: id forActions: actions on: html] 
		ifFalse: [actionsMap at: id put: actions]
		! !

!SGLActionPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/4/2010 18:15'!
showAsIconCount
	^ showAsIconCount! !

!SGLActionPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/4/2010 18:15'!
showAsIconCount: anObject
	showAsIconCount := anObject! !

SGLPresenter subclass: #SGLBrowserPresenter
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

SGLBrowserPresenter subclass: #SGLAccumulatorPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLAccumulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:41'!
actOnPaneAdded: anAnnouncement
	self addPane: anAnnouncement pane! !

!SGLAccumulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:42'!
actOnPaneSelected: anAnnouncement
	self selectPaneAt: anAnnouncement position! !

!SGLAccumulatorPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 8/29/2010 20:19'!
addPane: aPane
	|tabs|
	self flag: 'Check if the way to give the html to add:label:action: bellow is correct'.
	tabs := (self renderer html jQuery id: (self renderer uuidFor: self browser)).
	self renderer scriptFor: self browser add: ( 
		tabs glamourTabs 
			add: (self renderer html jQuery ajax
						html: [ :aRenderer |
							self renderPaneWithoutTitle: aPane on: aRenderer ];
						fullUrl) 			 
			label: [ :aRenderer | self renderTitleOrIconOf: aPane presentations on: aRenderer ]
			actions: [:aRenderer| self renderActionFromPane: aPane on: aRenderer ])! !

!SGLAccumulatorPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/30/2010 23:02'!
initializationScriptWith: html
	 ^ html jQuery this glamourTabs  
		cache: true; 
		hasActions: true;
		closable: true;
		onRemove: (self onRemoveActionWith: html);
		onSelect: (self onSelectScriptWith: html)! !

!SGLAccumulatorPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 20:59'!
initializeFor: aBrowser
	super initializeFor: aBrowser.
	self registerAnnouncers! !

!SGLAccumulatorPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/30/2010 23:02'!
onRemoveActionWith: html
	^ html jQuery ajax
			callbackTabs: [:event|
				self browser removePaneIndex: (event at: #index) + 1];
			script: [: script | self renderer updateScript: script ]! !

!SGLAccumulatorPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/30/2010 23:02'!
onSelectScriptWith: html
	^ html jQuery ajax 
			callbackTabs: [ :event | 
   	  	     		self browser activeEntity: ((self browser panes at: (event at: #index) + 1) port: #entity) value ];
			script: [: script | self renderer updateScript: script ]! !

!SGLAccumulatorPresenter methodsFor: 'initialization' stamp: 'AndreiChis 2/17/2011 16:42'!
registerAnnouncers
	self browser on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	self browser on: GLMPaneSelected send: #actOnPaneSelected: to: self.! !

!SGLAccumulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 20:07'!
renderActionFromPane: aPane on: html
	html listItem
		class: 'glm-actions';
		style: 'display: none;';
		with: [ self renderActionsFrom: aPane presentations on: html ]! !

!SGLAccumulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 20:24'!
renderContentOn: html
	|panes|
	panes := self browser panes.
	panes isEmpty ifTrue: [ ^ self renderEmptyPresentationOn: html ].
	html div
		id: (self renderer uuidFor: self browser);
		class: 'glm-accumulator';
		script: ( self initializationScriptWith: html );
		with: [
			html unorderedList: [
				self browser panes withIndexDo: [ :each :i |
					self renderPane: each at: i on: html ] ] ]! !

!SGLAccumulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 20:08'!
renderPane: aPane at: index on: html
	html listItem
		class: 'ui-tabs-selected' if: self browser panes size = index;  
		with: [
			html anchor
				url: (html jQuery ajax
					html: [ :aRenderer | 								
						self renderPaneWithoutTitle: aPane on: aRenderer ];
					fullUrl);
				with: [ self renderTitleOrIconOf: aPane presentations on: html ] ].
	self renderActionFromPane: aPane on: html
	! !

!SGLAccumulatorPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 8/29/2010 19:45'!
selectPaneAt: index
	self renderer scriptFor: self browser add:  (
		 (self renderer html jQuery id: (self renderer uuidFor: self browser)) glamourTabs select: index-1 ).! !

!SGLBrowserPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/29/2010 18:03'!
browser
	^browser! !

!SGLBrowserPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 18:03'!
initializeFor: aBrowser
	browser := aBrowser! !

SGLBrowserPresenter subclass: #SGLDashboardPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLDashboardPresenter methodsFor: 'private' stamp: 'cyrilledelaunay 5/23/2011 16:16'!
firstColumnPanesFrom: aGLMDashboard

	|tmpHalfSizePanes tmpResult|
	aGLMDashboard panes isEmpty ifTrue: [^#()].
	tmpResult := OrderedCollection new.
	tmpHalfSizePanes := (aGLMDashboard panes size / 2) asFloat rounded.
	1 to: tmpHalfSizePanes do: [:anIndex |
		tmpResult add: (aGLMDashboard panes at: anIndex)
		].
	^ tmpResult! !

!SGLDashboardPresenter methodsFor: 'private' stamp: 'cyrilledelaunay 7/29/2011 13:48'!
heightsOfPanes: aCollectionOfPanes

	^ (aCollectionOfPanes collect: [:each |
		(self browser extentOfPaneNamed: each name) y
		]) asArray! !

!SGLDashboardPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/28/2011 13:39'!
renderColumnPane: aPane on: html

	| tag |
	tag := html div.
	tag 
		script: (html jQuery new glamourDashboardCell);
		with: [ self render: aPane on: html].! !

!SGLDashboardPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/19/2011 13:53'!
renderColumnWith: aCollectionOfPanes on: html
	
	aCollectionOfPanes do: [:currentPane |
		self renderColumnPane:  currentPane on: html.
		]
	! !

!SGLDashboardPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/13/2011 14:23'!
renderContentOn: html
	
	 self renderMainDivOn: html
	! !

!SGLDashboardPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/28/2011 13:19'!
renderMainDivOn: html

	html div 
		script: (self resizeAndSplitVerticalyScriptOn: html);
		script: (html jQuery this css: (Dictionary new 
			at: 'overflow' put: 'auto';
			yourself));
		with: [
			html div
				script: (html jQuery new glamourDashboardColumn cellHeight: (self heightsOfPanes: (self firstColumnPanesFrom: self browser) ) );
				with: [
					self renderColumnWith: (self firstColumnPanesFrom: self browser) on: html.
				].
				
			html div 
				script: (html jQuery new glamourDashboardColumn cellHeight: (self heightsOfPanes: (self secondColumnPanesFrom: self browser) ));
				with: [self renderColumnWith: (self secondColumnPanesFrom: self browser) on: html.]  
			]
	


	"example to see how to display a tabulator"	
			
			"html div 
			script: html jQuery new glamourDashboard;				
			with:[
							
					html div
						script: html jQuery new glamourDashboard;
						with: [
							self render: ((self firstColumnPanesFrom: self browser) at: 4) on: html
							].
					html div
						script: html jQuery new glamourDashboard;
						with: [
							self render: ((self firstColumnPanesFrom: self browser) at: 2) on: html
							].
					html div	
						script: html jQuery new glamourDashboard;
						with: [
							self render: ((self firstColumnPanesFrom: self browser) at: 1) on: html
							].

						]"
			
! !

!SGLDashboardPresenter methodsFor: 'jQuery-scripts' stamp: 'cyrilledelaunay 7/13/2011 14:04'!
resizeAndSplitHorizontalyScriptOn: html
	^ html jQuery new glamourResize
		"paneASpan: 1 ;
		remainingSpan: 1;"
	 	splitHorizontal.! !

!SGLDashboardPresenter methodsFor: 'jQuery-scripts' stamp: 'cyrilledelaunay 7/29/2011 13:51'!
resizeAndSplitVerticalyScriptOn: html
	^ html jQuery new glamourResize 
			splitVertical.! !

!SGLDashboardPresenter methodsFor: 'jQuery-scripts' stamp: 'cyrilledelaunay 7/13/2011 15:02'!
resizeHorizontalyScriptOn: html
	^ html jQuery new glamourResizeHorizontaly
		"paneASpan: 1 ;
		remainingSpan: 1;"
	 	"splitHorizontal."! !

!SGLDashboardPresenter methodsFor: 'jQuery-scripts' stamp: 'cyrilledelaunay 7/13/2011 14:01'!
resizeScriptOn: html
	^ html jQuery new glamourResize
		"paneASpan: 1 ;
		remainingSpan: 1;"
	 	"splitHorizontal."! !

!SGLDashboardPresenter methodsFor: 'private' stamp: 'cyrilledelaunay 5/23/2011 16:16'!
secondColumnPanesFrom: aGLMDashboard

	|tmpHalfSizePanes tmpResult|
	aGLMDashboard panes isEmpty ifTrue: [^#()].
	tmpResult := OrderedCollection new.
	tmpHalfSizePanes := (aGLMDashboard panes size / 2) asFloat rounded.
	(tmpHalfSizePanes + 1) to: aGLMDashboard panes size do: [:anIndex |
		tmpResult add: (aGLMDashboard panes at: anIndex)
		].
	^ tmpResult! !

SGLBrowserPresenter subclass: #SGLExpanderPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLExpanderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:45'!
actOnPaneAdded: anAnnouncement
	self addPane: anAnnouncement pane! !

!SGLExpanderPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 1/11/2011 22:26'!
addPane: aPane
	self renderer 
		scriptFor: self browser 
		add: ((self renderer html jQuery id: (self renderer uuidFor: self browser))
			glamourExpander addPane: [ :aRenderer | self renderPaneHeaderFor: aPane on: aRenderer ] )
	! !

!SGLExpanderPresenter methodsFor: 'initialization' stamp: 'AndreiChis 2/17/2011 16:46'!
initializeFor: aBrowser
	super initializeFor: aBrowser.
	self browser on: GLMPaneAdded send: #actOnPaneAdded: to: self.! !

!SGLExpanderPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 1/11/2011 22:17'!
loadContentScriptFor: aPane with: html
	^ html jQuery ajax
		html: [ :aRenderer | 				
			self renderPaneContentFor: aPane on: aRenderer];
		fullUrl! !

!SGLExpanderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 1/11/2011 16:38'!
renderContentOn: html
	|panes|
	
	panes := self browser panes.
	panes isEmpty ifTrue: [ ^ self renderEmptyPresentationOn: html ].
	html div
		id: (self renderer uuidFor: self browser);		
		script: ( html jQuery new glamourExpander );
		with: [			
			panes do: [ :each |
				self renderPaneHeaderFor: each on: html ] ]! !

!SGLExpanderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 1/11/2011 16:10'!
renderPaneAnchorFor: aPane on: html
	html anchor
		url: (self loadContentScriptFor: aPane with: html);
		with: [ self renderTitleOrIconOf: aPane presentations on: html ]! !

!SGLExpanderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 1/11/2011 22:17'!
renderPaneContentFor: aPane on: html
	self render: aPane presentations on: html! !

!SGLExpanderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 1/11/2011 19:14'!
renderPaneHeaderFor: aPane on: html
	html heading 
		level: 3;
		with: [
			self renderPaneAnchorFor: aPane on: html.
			self renderActionsFrom: aPane presentations on: html  ]! !

SGLBrowserPresenter subclass: #SGLFinderPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLFinderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 17:10'!
actOnPaneAdded: anAnnouncement
	self addPane: anAnnouncement pane! !

!SGLFinderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/19/2011 21:21'!
actOnPaneRemoved: anAnnouncement
	self removeLastPane! !

!SGLFinderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 17:12'!
actOnPaneReplaced: anAnnouncement
	self replaceLastPaneWith: anAnnouncement newPane ! !

!SGLFinderPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 2/18/2011 20:11'!
addPane: aPane
	self renderer 
		scriptFor: self browser 
		add: ((self renderer html jQuery id: (self renderer uuidFor: self browser))
			glamourFinder addPane: [ :aRenderer | self renderPane: aPane on: aRenderer ]).! !

!SGLFinderPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 20:59'!
initializeFor: aBrowser
	super initializeFor: aBrowser.
	self registerAnnouncers! !

!SGLFinderPresenter methodsFor: 'initialization' stamp: 'AndreiChis 2/17/2011 17:13'!
registerAnnouncers
	self browser on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	self browser on: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	self browser on: GLMPaneReplaced send: #actOnPaneReplaced: to: self.! !

!SGLFinderPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 2/19/2011 21:21'!
removeLastPane
	self renderer 
		scriptFor: self browser 
		add: ((self renderer html jQuery id: (self renderer uuidFor: self browser))
			glamourFinder removeLastPane)! !

!SGLFinderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/20/2011 00:06'!
renderContentOn: html
	html div		
		id: (self renderer uuidFor: self browser); 		
		script: (html jQuery new glamourFinder);
		with: [
			self browser panes 
				do: [ :each | self renderPane: each on: html ] ] .! !

!SGLFinderPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/20/2011 00:06'!
renderPane: aPane on: html
	html div		
		id: (self renderer uuidFor: aPane);
		with: [ self renderer render: aPane ]! !

!SGLFinderPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 2/19/2011 21:20'!
replaceLastPaneWith: newPane
	self renderer 
		scriptFor: self browser 
		add: ((self renderer html jQuery id: (self renderer uuidFor: self browser))
			glamourFinder replaceLastPane: [ :aRenderer | self renderPane: newPane on: aRenderer ])! !

SGLBrowserPresenter subclass: #SGLStackerPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLStackerPresenter methodsFor: 'jQuery-scripts' stamp: 'DamienCassou 7/24/2011 16:40'!
loadContentScriptFor: aTab with: html
	^ html jQuery ajax
		html: [ :aRenderer | self render: aTab on: aRenderer];
		fullUrl! !

!SGLStackerPresenter methodsFor: 'accessing' stamp: 'DamienCassou 7/24/2011 16:25'!
panes
	^ self browser panes! !

!SGLStackerPresenter methodsFor: 'rendering' stamp: 'DamienCassou 7/24/2011 16:19'!
renderContentOn: html
	html div
		class: 'tabbed-arrangement';
		script: (self tabScriptWith: html);
		with: [self renderTabsHeaderOn: html]! !

!SGLStackerPresenter methodsFor: 'rendering' stamp: 'DamienCassou 7/24/2011 16:41'!
renderTab: aPane on: html 
	html listItem 
		id: html nextId;
		with: [ self renderTabAchorFor: aPane on: html ]! !

!SGLStackerPresenter methodsFor: 'rendering' stamp: 'DamienCassou 7/24/2011 16:35'!
renderTabAchorFor: aTab on: html
	html anchor
		url: (self loadContentScriptFor: aTab with: html);
		with: [self renderTitleOrIconOf: aTab presentations on: html]! !

!SGLStackerPresenter methodsFor: 'rendering' stamp: 'DamienCassou 7/24/2011 16:40'!
renderTabsHeaderOn: html
	html unorderedList: [self panes do: [ :pane | self renderTab: pane on: html] ]! !

!SGLStackerPresenter methodsFor: 'rendering' stamp: 'DamienCassou 7/24/2011 16:37'!
tabScriptWith: html
	^ html jQuery new glamourTabs
		cache: true; 
		hasActions: true;
		closable: true! !

SGLBrowserPresenter subclass: #SGLTabulatorPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTabulatorPresenter methodsFor: 'private' stamp: 'AndreiChis 11/30/2010 14:37'!
computeTotalSpanForCell: aCell
	|totalSpan|
	totalSpan := 0.
	aCell children do: [ :each |
		totalSpan := totalSpan + each span ].
	^ totalSpan ! !

!SGLTabulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 11/30/2010 14:38'!
renderContentOn: html
	|totalSpan|
	totalSpan := self computeTotalSpanForCell: self browser cell.
	self browser cell isRow
		ifTrue: [ self renderTableLayoutRow: self browser cell fromIndex: 1 withSpan: totalSpan on: html]
		ifFalse: [ self renderTableLayoutColumn: self browser cell fromIndex: 1 withSpan: totalSpan on: html ]! !

!SGLTabulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 11/30/2010 14:38'!
renderTableColumn: aCell on: html
	| tag |
	tag := html div.
	aCell hasId 
		ifTrue: [
			| pane |
			pane := self browser paneNamed: aCell id.
			tag id: (self renderer uuidFor: pane); with: [ self render: pane on: html ] ]
		ifFalse: [ 
			tag with: [ self renderTableLayoutRow: aCell fromIndex: 1 withSpan: (self computeTotalSpanForCell: aCell) on: html ] ] ! !

!SGLTabulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 11/30/2010 15:06'!
renderTableLayoutColumn: aCell fromIndex: index withSpan: span on: html
	| currentCell |
	currentCell  := aCell children at: index.
	html div 
		class: 'sgl-table'; 
		id: html nextId; 
		script: (self resizeHorizontalScriptWithCell: currentCell withSpan:  span - currentCell span on: html);
		with: [
			(aCell children size > 0) ifTrue: [
				self renderTableColumn: (aCell children at: index) on: html.
				(aCell children size = 1) ifFalse: [		
					(aCell children size = (index + 1)) 
						ifTrue: [ self renderTableColumn: (aCell children at: index+1) on: html ] 
						ifFalse: [ self renderTableLayoutColumn: aCell fromIndex: index+1withSpan: span - currentCell span on: html ] ] ] ]! !

!SGLTabulatorPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/23/2011 16:44'!
renderTableLayoutRow: aCell fromIndex: index withSpan: span on: html
	| currentCell |
	currentCell  := aCell children at: index.
	html div 
		class: 'sgl-table'; 
		id: html nextId; 
		script: (self resizeVerticalScriptWithCell: currentCell withSpan:  span - currentCell span on: html);
		with: [
			(aCell children size > 0) ifTrue: [
				self renderTableRow: (aCell children at: index) on: html.
				(aCell children size = 1) ifFalse: [		
					(aCell children size = (index + 1)) 
						ifTrue: [ self renderTableRow: (aCell children at: index+1) on: html ] 
						ifFalse: [ self renderTableLayoutRow: aCell fromIndex: index+1 withSpan: span - currentCell span on: html ] ] ] ]! !

!SGLTabulatorPresenter methodsFor: 'rendering' stamp: 'AndreiChis 11/30/2010 14:56'!
renderTableRow: aCell on: html
	| tag |
	tag := html div.
	aCell hasId 
		ifTrue: [
			| pane |
			pane := self browser paneNamed: aCell id.
			tag id: (self renderer uuidFor: pane); with: [ self render: pane on: html ] ]
		ifFalse: [ 
			tag with: [ self renderTableLayoutColumn: aCell fromIndex: 1withSpan: (self computeTotalSpanForCell: aCell) on: html ] ] 
! !

!SGLTabulatorPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 11/30/2010 14:41'!
resizeHorizontalScriptWithCell: aCell withSpan: span on: html
	^ html jQuery new glamourResize splitHorizontal 
		paneASpan: aCell span;
		remainingSpan: span ! !

!SGLTabulatorPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 11/30/2010 14:51'!
resizeVerticalScriptWithCell: aCell withSpan: span on: html
	^ html jQuery new glamourResize splitVertical
		paneASpan: aCell span;
		remainingSpan: span ! !

SGLBrowserPresenter subclass: #SGLValidatorPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLValidatorPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 8/5/2011 15:32'!
renderContentOn: html

	html div 
		script: (html jQuery new glamourValidator buttonsHeight: 50);
		with: [
			html div
				script: (html jQuery new glamourValidatorBrowser);
				with: [
					self render: self browser panes first on: html.
					].
			html div 
				with: [
				self browser buttonActions do: [:aGLMAction |
				
					html button 
						script: (html jQuery new css: (
							Dictionary new 
								at: 'float' put: 'right';
								at: 'margin-top' put: '10px';
								at: 'margin-left' put: '5px';
								at: 'margin-right' put: '5px';
								at: 'padding-top' put: '3px';
								at: 'padding-left' put: '3px';
								at: 'padding-right' put: '3px';
								at: 'padding-bottom' put: '3px';
								yourself
								));
						onClick:((html jQuery ajax)
							script: [:s | 
								(GLMButtonModel new 
									glamourPresentation: self browser;
									glamourAction: aGLMAction;
									yourself) execute.
								self renderer updateScript: s
								]);
							value: aGLMAction title]
				
			].
			
			
		] ! !

SGLBrowserPresenter subclass: #SGLWizardPresenter
	instanceVariableNames: 'mainId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLWizardPresenter methodsFor: 'callback' stamp: 'cyrilledelaunay 8/5/2011 16:32'!
actOnBrowserClosed: ann

	self renderer component answer! !

!SGLWizardPresenter methodsFor: 'callback' stamp: 'cyrilledelaunay 8/5/2011 17:08'!
actOnPaneAdded: ann

	self renderer 
		scriptFor: self browser 
		add:
			(
			(self renderer html jQuery id: self mainId) parent "load"
         			html: [ :r | 
						r div
							id: self mainId;
							script: (r jQuery new glamourWizard);
							with: [
								self render: (self browser stepsAndPanes at: self browser currentStep) last on: r 
								]
							
					]
			).
			
	"self renderer 
		scriptFor: self browser 
		add:
			((self renderer html jQuery id: self mainId) call: 'resize')"! !

!SGLWizardPresenter methodsFor: 'callback' stamp: 'cyrilledelaunay 8/5/2011 17:11'!
actOnPaneRemoved: ann

	self renderer 
		scriptFor: self browser 
		add:
			(
			(self renderer html jQuery id: self mainId) parent "load"
         			html: [ :r | 
						r div
							id: self mainId;
							script: (r jQuery new glamourWizard);
							with: [
								self render: (self browser stepsAndPanes at: self browser currentStep) last on: r 
								]
							
					]
			).! !

!SGLWizardPresenter methodsFor: 'callback' stamp: 'cyrilledelaunay 8/5/2011 17:11'!
actOnPaneReplaced: ann

	self renderer 
		scriptFor: self browser 
		add:
			(
			(self renderer html jQuery id: self mainId) parent "load"
         			html: [ :r | 
						r div
							id: self mainId;
							script: (r jQuery new glamourWizard);
							with: [
								self render: (self browser stepsAndPanes at: self browser currentStep) last on: r 
								]
							
					]
			).! !

!SGLWizardPresenter methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/5/2011 11:03'!
mainId

	^ mainId! !

!SGLWizardPresenter methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/5/2011 11:02'!
mainId: anId

	mainId := anId! !

!SGLWizardPresenter methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/4/2011 15:57'!
registerAnnouncementsFor: aBrowser
	
	aBrowser 
		on: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser 
		on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser 
		on: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser 
		on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.! !

!SGLWizardPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 8/5/2011 16:21'!
renderContentOn:  html

	self registerAnnouncementsFor: self browser.
	self mainId: html nextId.
	html div
		id: self mainId;
		script: html jQuery new glamourWizard;
		with: [
			self render: (self browser stepsAndPanes at: self browser currentStep) last on: html
			]
	! !

SGLPresenter subclass: #SGLCompositePresenter
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

SGLCompositePresenter subclass: #SGLAccordionCompositePresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLAccordionCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 9/6/2010 23:25'!
renderContentOn: html
	| presentations index |
	presentations := self presentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ self renderEmptyPresentationOn: html ].
	presentations size = 1 ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	
	index := self indexForSelectedPresentation.
	html div
		class: 'accordion-arrangement';
  	      script: (html jQuery new accordion animated: false; clearStyle: true; active: index-1);
   	      with: [
         		presentations withIndexDo: [ :each :i | 
				html div: [ 
					html anchor: each titleValue. 
					self renderActionsFrom: each on: html ].
				html div: [ self render: each on: html ] ] ]! !

!SGLCompositePresenter methodsFor: 'private' stamp: 'AndreiChis 8/29/2010 17:40'!
indexForSelectedPresentation
	|index|
	index := 1.
	self presentation matchingPresentations withIndexDo: [ :each :i | 
		self presentation pane lastActivePresentation notNil and: [ 
			each title = self presentation pane lastActivePresentation title ifTrue: [ index := i ] ] ].
	^ index! !

!SGLCompositePresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 17:32'!
initializeFor: aPresentation
	presentation := aPresentation! !

!SGLCompositePresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/29/2010 17:31'!
presentation
	^ presentation! !

SGLCompositePresenter subclass: #SGLStackedVerticallyCompositePresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLStackedVerticallyCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 12/8/2010 13:19'!
renderContentOn: html
	| presentations|
	presentations := self presentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ self renderEmptyPresentationOn: html ].	
	presentations size = 1 ifTrue: [^ self renderWithTitleOrNil: presentations first on: html ].
	
	html div 
		class: 'ui-widget ui-widget-content ui-corner-all';
		class: 'sgl-stacked-arrangement';
		script: (html jQuery new glamourStack);
		with: [
			presentations do: [ :each | 
				self renderWithTitle: each andAddCloseButton: true on: html ] ]! !

SGLCompositePresenter subclass: #SGLTabbedCompositePresenter
	instanceVariableNames: 'actionsPresenters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTabbedCompositePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/29/2010 17:16'!
loadContentScriptFor: aTab with: html
	^ html jQuery ajax
		html: [ :aRenderer | 				
			self render: aTab on: aRenderer];
		fullUrl! !

!SGLTabbedCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/8/2011 22:08'!
renderActionsFromTab: aTab on: html
	|actionsPresenter|

	html listItem
		class: 'glm-actions';
		style: 'display: none;';
		with: [ 
			"super renderActionsFrom: aTab on: html "
			actionsPresenter := self renderActionsHeaderFrom: aTab on: html ].
	^ actionsPresenter! !

!SGLTabbedCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/8/2011 22:10'!
renderContentOn: html
	| presentations |
	presentations := self presentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^self renderEmptyPresentationOn: html ].
	presentations size = 1 ifTrue: [^self renderWithTitleOrNil: presentations first on: html ].
	html div
		class: 'tabbed-arrangement';
		script: (self tabScriptWith: html);
		with: [ 
			self renderTabsHeaderOn: html.
			actionsPresenters do: [:each|
				self renderActionsContentFrom: each on: html ] ]! !

!SGLTabbedCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/14/2010 00:08'!
renderTab: aTab asSelectedIf: isSelected on: html
	html listItem 
		class: 'ui-tabs-selected' if: isSelected; 
		id: html nextId;
		with: [ self renderTabAchorFor: aTab on: html ]! !

!SGLTabbedCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 03:48'!
renderTabAchorFor: aTab on: html
	html anchor
		url: (self loadContentScriptFor: aTab with: html);
		with: [self renderTitleOrIconOf: aTab on: html]! !

!SGLTabbedCompositePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/8/2011 22:11'!
renderTabsHeaderOn: html
	|index|
	index := self indexForSelectedPresentation.
	actionsPresenters := Array new: self presentation matchingPresentations size.
	html unorderedList: [
		self presentation matchingPresentations withIndexDo: [ :each :i|
			self renderTab: each asSelectedIf: i = index on: html.
			actionsPresenters at: i put: (self renderActionsFromTab: each on: html) ] ]! !

!SGLTabbedCompositePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/29/2010 03:30'!
tabScriptWith: html
	^ html jQuery new glamourTabs
		cache: true; 
		hasActions: true;
		closable: true;
		onSelect: (html jQuery ajax callbackTabs: [ :event | 
       		self presentation pane lastActivePresentation: ( self presentation matchingPresentations at: (event at: #index)+1 ) ]) ! !

SGLPresenter subclass: #SGLDynamicPresenter
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLDynamicPresenter methodsFor: 'initialization' stamp: 'AndreiChis 2/17/2011 17:19'!
initializeFor: aPresentation
	presentation := aPresentation! !

!SGLDynamicPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 17:25'!
renderContentOn: html
	self renderer render: presentation currentPresentation! !

SGLPresenter subclass: #SGLEyeSeePresenter
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLEyeSeePresenter methodsFor: 'private' stamp: 'AndreHora 4/27/2011 14:33'!
eyeSeeCanvas

	| diagramRenderer canvas |
	
	diagramRenderer := ESDiagramRenderer new.
	self presentation renderOn: diagramRenderer.
	
	canvas := diagramRenderer canvas.
	canvas selected: self presentation selectedElement.
	
	^ canvas! !

!SGLEyeSeePresenter methodsFor: 'initialization' stamp: 'AndreHora 4/26/2011 15:53'!
initializeFor: aPresentation

	presentation := aPresentation! !

!SGLEyeSeePresenter methodsFor: 'accessing' stamp: 'AndreHora 4/26/2011 15:53'!
presentation

	^ presentation! !

!SGLEyeSeePresenter methodsFor: 'rendering' stamp: 'AndreHora 4/27/2011 14:51'!
renderContentOn: html

	html div
		id: (self renderer uuidFor: self presentation);
		with: [ self renderImageOn: html ]! !

!SGLEyeSeePresenter methodsFor: 'rendering' stamp: 'AndreHora 4/27/2011 14:01'!
renderImageOn: html

	| canvas |
	
	canvas := self eyeSeeCanvas.
	html image
		form: canvas imageForm;
		onClick: (html jQuery ajax 
			callback: [ :value |
				| coordinates element |
				coordinates := (value contents findTokens: $,)
					collect: [ :each | each asNumber ].
				element := canvas diagram atPoint: coordinates first @ coordinates second.
				self presentation selection: (element ifNotNil: [ element model ]).
				self presentation selectedElement: element ]
			value: (JSStream on: 'event.layerX+","+event.layerY');
			script: [ :script |
				self renderer scriptFor: self presentation put: ((html jQuery id: (self renderer uuidFor: self presentation))
					replaceWith: [ :aRenderer | aRenderer render: self ]).
				self renderer updateScript: script ])! !

SGLPresenter subclass: #SGLMondrianPresenter
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLMondrianPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 21:36'!
initializeFor: aPresentation
	presentation := aPresentation! !

!SGLMondrianPresenter methodsFor: 'private' stamp: 'AndreHora 4/26/2011 14:59'!
mondrianCanvas
	| view canvas |
	view := MOViewRenderer new.
	self presentation renderOn: view. 
	canvas := MOCanvas new. 
	canvas root: view root.
	canvas selected: (view 
		nodeForDomainValue: self presentation selection 
		ifAbsent: [ nil ]).
	^ canvas! !

!SGLMondrianPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/29/2010 21:36'!
presentation
	^ presentation! !

!SGLMondrianPresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 21:44'!
renderContentOn: html
	html div
		id: (self renderer uuidFor: self presentation);
		class: 'glm-mondrian-presentation';
		with: [ self renderImageOn: html ]! !

!SGLMondrianPresenter methodsFor: 'rendering' stamp: 'AndreHora 4/27/2011 11:51'!
renderImageOn: html
	| canvas |
	canvas := self mondrianCanvas.
	html image
		form: canvas imageForm;	
		onClick: (html jQuery ajax 
			callback: [ :value |
				| coordinates element |
				coordinates := (value contents findTokens: $,)
					collect: [ :each | each asNumber ].
				element := canvas root elementAt: coordinates first @ coordinates second.
				self presentation selection: (element isNil
					ifFalse: [ element model ]) ]
			value: (JSStream on: 'event.layerX+","+event.layerY');
			script: [ :script |
				self renderer scriptFor: self presentation put: ((html jQuery id: (self renderer uuidFor: self presentation))
					replaceWith: [ :aRenderer | aRenderer render: self ]).
				self renderer updateScript: script ])! !

SGLPresenter subclass: #SGLPanePresenter
	instanceVariableNames: 'pane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLPanePresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:11'!
actOnMatchingPresentationChanged: anAnnouncement 
	self renderer
		scriptFor: pane
		put: ((self renderer html jQuery id: (self renderer uuidFor: pane))
			glamourHtml: [ :aRenderer |
				self renderPaneOn: aRenderer])! !

!SGLPanePresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 18:54'!
initializeFor: aPane
	pane := aPane! !

!SGLPanePresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:19'!
renderContentOn: html
	pane 
		on: GLMMatchingPresentationsChanged 
		send: #actOnMatchingPresentationChanged: 
		to: self.
	self renderPaneOn: html
	
! !

!SGLPanePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 18:47'!
renderPaneOn: html
	self renderWithTitleOrNil: pane presentations on: html! !

SGLPanePresenter subclass: #SGLPaneWithoutTitlePresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLPaneWithoutTitlePresenter methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 18:49'!
renderPaneOn: html
	self render: pane presentations on: html! !

!SGLPresenter classSide methodsFor: 'instance creation' stamp: 'AndreiChis 9/2/2010 18:55'!
for: anObject from: aRenderer
	^ self basicNew initializeFor: anObject from: aRenderer! !

!SGLPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 17:00'!
initializeFor: anObject
	self subclassResponsibility! !

!SGLPresenter methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 17:00'!
initializeFor: anObject from: aRenderer
	self initialize.
	self renderer: aRenderer.
	self initializeFor: anObject! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:48'!
render: aRenderable on: html
	self renderer render: aRenderable on: html! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 8/6/2011 14:24'!
renderActionsContentFrom: aPresenter on: html
	aPresenter renderMbMenuForCachedActionsOn: html! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:48'!
renderActionsFrom: aPresentation on: html
	html render: (SGLActionPresenter for: aPresentation from: self renderer) ! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 8/6/2011 14:20'!
renderActionsHeaderFrom: aPresentation on: html
	|presenter|
	presenter := SGLActionPresenter for: aPresentation from: self renderer.
	presenter fullRendering: false.
	html render: presenter.
	^ presenter ! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:48'!
renderEmptyPresentationOn: html
	html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all';
		class: 'glm-empty-presentation'! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:48'!
renderPaneWithoutTitle: aPane on: html
	html render: (SGLPaneWithoutTitlePresenter for: aPane from: self)! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:49'!
renderTitleOrIconOf: aPresentation on: html
	aPresentation hasTitleIcon
		ifTrue: [ 
			html image
				form: aPresentation titleIconValue  ] 
		ifFalse:  [ html render: (aPresentation titleValue ifNil: ['']) ]! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 8/8/2011 21:45'!
renderWithTitle: aPresentation andAddCloseButton: aBoolean on: html
	|id actionsPresenter|
	id := html nextId.
	(self widgetContainerWith: html)
		script: ( html jQuery new glamourTabs
			ifEmptyDo: 'remove';
			hasActions: true;
			closable: aBoolean );
		class: 'presentation-with-title';
		with: [
			html unorderedList				
				class: 'presentation-title';
				with: [
					html listItem: [ 
							html anchor
								url: '#', id asString;
								with: [self renderTitleOrIconOf: aPresentation on: html]  ].
					html listItem 
						class: 'glm-actions';
						with: [actionsPresenter := self renderActionsHeaderFrom: aPresentation on: html].
					].
			html div
				id: id;				
				class: 'presentation-content';
				with: [
					self render: aPresentation on: html ].
			self renderActionsContentFrom: actionsPresenter on: html ] ! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:49'!
renderWithTitle: aPresentation on: html
	self renderWithTitle: aPresentation andAddCloseButton: false on: html! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:49'!
renderWithTitleOrNil: aPresentation on: html
	(aPresentation hasTitleIcon or: [aPresentation hasTitle]) ifFalse: [ ^ self render: aPresentation on: html ].
	self renderWithTitle: aPresentation on: html! !

!SGLPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/29/2010 02:44'!
renderer
	^ renderer! !

!SGLPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/29/2010 02:44'!
renderer: anObject
	renderer := anObject! !

!SGLPresenter methodsFor: 'private' stamp: 'AndreiChis 2/17/2011 17:49'!
widgetContainerWith: html
	^ html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all';
		yourself! !

SGLPresenter subclass: #SGLTextPresenter
	instanceVariableNames: 'model htmlId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTextPresenter commentStamp: '<historical>' prior: 0!
SGLTextPresenter has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	renderer	<SGLRenderer>
	model	<SGLTextModel>
	htmlId	<ProtoObject | PseudoContext>
	isSelectionNil	<Boolean>
		Indicates if the selection should be set to nil.!

!SGLTextPresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:28'!
actOnContextChanged: anAnnouncement
	( #(#text #selectionInterval #selectedText) includes:  anAnnouncement property) 
		ifTrue: [
			model announcer suspendAllWhile: [
				self perform: ( ('update', anAnnouncement property asString capitalized) , ':' ) asSymbol with: anAnnouncement value ] ]! !

!SGLTextPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 01:35'!
htmlId
	^ htmlId! !

!SGLTextPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 01:35'!
htmlId: anObject
	htmlId := anObject! !

!SGLTextPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/30/2010 23:00'!
initializationScriptWith: html
	^ html jQuery this glamourText 
			onSelect: ( self onSelectActionWith: html );
			onChange: ( self onChangeActionWith: html )! !

!SGLTextPresenter methodsFor: 'initialization' stamp: 'AndreiChis 2/17/2011 16:29'!
initializeFor: aPresentation
	model := SGLTextModel for: aPresentation.
	
	"When the glamour model changes, we want to update the presenter"
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	"aPresentation when: GLMPresentationUpdated do: [:ann | ]."
	! !

!SGLTextPresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/29/2010 03:56'!
model
	^ model! !

!SGLTextPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 8/30/2010 23:00'!
onChangeActionWith: html
	^ html jQuery ajax
		sglCallbackText:  [ :event :script |
			self model text: (event at: 'text').
			self updateSelectionScript.
			self renderer updateScript: script  ]! !

!SGLTextPresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 9/2/2010 02:04'!
onSelectActionWith: html
	^ html jQuery ajax 
		sglCallbackText: [ :event :script |
			((event at: 'port') = 'selection')
				ifTrue: [  | interval |
					interval := Interval from: (event at: 'start') to: (event at: 'end').
					self model 
						selectionInterval: interval 
						withSelectedText: (self model selectionForInterval: interval)	].
			((event at: 'port') = 'selectedText')
				ifTrue: [
					self model 
						selectionInterval:  (self model intervalForSelection: (event at: 'selection') ) ].
			((event at: 'port') = 'selectionInterval')
				ifTrue: [
					self model 
						selectedText: (self model selectionForInterval: (Interval from: (event at: 'start') to: (event at: 'end') ) ) ].
			self renderer updateScript: script ]! !

!SGLTextPresenter methodsFor: 'rendering' stamp: 'AndreiChis 9/5/2010 21:28'!
renderContentOn: html
	self model addInitialSelections.
	htmlId := self renderer uuidFor: model glamourPresentation.
	html div
		class: 'ui-widget ui-widget-content ui-corner-all';
		class: 'presentation-container glm-text-presentation';
		with: [ self renderTextAreaOn: html ]! !

!SGLTextPresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 11:54'!
renderTextAreaOn: html
	html textArea
		id: htmlId;
		value: self model glamourPresentation formatedDisplayValue;
		script: (self initializationScriptWith: html)! !

!SGLTextPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 9/2/2010 00:37'!
updateSelectedText: aSelection
	self model selectedText: aSelection.
	self updateSelectedTextScriptWith: aSelection! !

!SGLTextPresenter methodsFor: 'private' stamp: 'AndreiChis 9/1/2010 23:36'!
updateSelectedTextScriptWith: aSelection
	self renderer
		scriptFor: self model glamourPresentation 
		add: ( ( (self renderer html jQuery id: (
			self renderer uuidFor: self model glamourPresentation) )  glamourText ) selectText: (aSelection ifNil: ['']) )! !

!SGLTextPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 9/2/2010 00:37'!
updateSelectionInterval: anInterval
	self model selectionInterval: anInterval.
	self updateSelectionIntervalScriptWith: anInterval! !

!SGLTextPresenter methodsFor: 'private' stamp: 'AndreiChis 8/29/2010 03:58'!
updateSelectionIntervalScriptWith: anInterval
	self renderer
		scriptFor: self model glamourPresentation 
		add: ( ( (self renderer html jQuery id: (
			self renderer uuidFor: self model glamourPresentation) )  glamourText ) 
				selectFrom: (anInterval ifNil: [0] ifNotNil: [anInterval first ])
				to: (anInterval ifNil: [0] ifNotNil: [anInterval last]) )! !

!SGLTextPresenter methodsFor: 'private' stamp: 'AndreiChis 8/29/2010 03:58'!
updateSelectionScript
	self model selectionInterval 
		ifNil: [
			self model selectedText  ifNotNil: [
				self updateSelectedTextScriptWith: self model selectedText ] ] 
		ifNotNil:  [
			self updateSelectionIntervalScriptWith: self model selectionInterval ]
	
		! !

!SGLTextPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 9/1/2010 23:36'!
updateText: aText
	self model text: aText.
	self updateSelectionScript.
	self updateTextScriptWith: aText! !

!SGLTextPresenter methodsFor: 'callbacks' stamp: 'AndreiChis 9/1/2010 23:35'!
updateTextScriptWith: aText
	self renderer 
		scriptFor: self model glamourPresentation 
		add: ( ( (self renderer html jQuery id: (
			self renderer uuidFor: self model glamourPresentation) )  glamourText ) changeText: (aText ifNil: ['']) )! !

SGLPresenter subclass: #SGLTreePresenter
	instanceVariableNames: 'model htmlId nodesId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 11:56'!
actOnContextChanged: anAnnouncement
	anAnnouncement property = #selection ifTrue: [ 
		model announcer suspendAllWhile: [
			model explicitSelection: anAnnouncement value.
			self updateSelectedNodes.
			 ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 16:25'!
actOnUpdatedPresentation: anAnnouncement
	model updateRoots! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 04:52'!
associateNode: aNode withId: anId
	nodesId at: aNode ifAbsentPut: anId! !

!SGLTreePresenter methodsFor: 'selection' stamp: 'AndreiChis 7/28/2010 23:25'!
explicitSelection: aNodeOrCollection
	self model glamourPresentation isMultiple 
		ifTrue: [ 
			|nodesPaths|
			nodesPaths := OrderedCollection new.
			aNodeOrCollection isCollection 
				ifTrue: [ aNodeOrCollection do: [:each | nodesPaths add: each path ] ] 
				ifFalse: [nodesPaths add: aNodeOrCollection path]. 
			self model selectAllNodePaths: nodesPaths ]
		ifFalse: [ self model selectNodePath: aNodeOrCollection path]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 12:28'!
fullTextCssScriptForNode: aNode With: html
	^ html jQuery this css: aNode displayText cssDictionaryForFullText! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 7/27/2010 19:42'!
htmlId
	^ htmlId! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 7/27/2010 19:42'!
htmlId: anObject
	htmlId := anObject! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 05:00'!
idOfNode: aNode
	^ nodesId at: aNode ifAbsent: [nil]! !

!SGLTreePresenter methodsFor: 'initialization' stamp: 'cyrilledelaunay 7/27/2011 11:04'!
initializeFor: aPresentation
	model := SGLTreeModel for: aPresentation.
	nodesId := Dictionary new.
	
	"When the glamour model changes, we want to update the morph"
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation on: GLMPresentationUpdated send: #actOnUpdatedPresentation: to: self.! !

!SGLTreePresenter methodsFor: 'initialization' stamp: 'AndreiChis 10/21/2010 22:48'!
initializeModelSelection: html
	self model updateModelSelection.
	self model selection ifNotNil: [ self model selection selectedNodes do: [:each|
			each shouldBeDisplayed ifTrue: [
				"Add an id so selectedIds can compute the selected ids before the tree is rendered."
				self associateNode: each withId: html nextId.
				"Make sure the selected nodes are rendered."
				each expandParentPath ] ] ].! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 7/28/2010 16:14'!
model
	^ model! !

!SGLTreePresenter methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 04:19'!
nodeForId: anId
	|value|
	value := nodesId keyAtValue: anId.
	^ value! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 1/5/2011 23:37'!
onAppendRootsURLWith: html
	^ html jQuery ajax 
		sglTreeCallbackAppendRootsURL:  [ :value :script |
			| endIndex stepSize |
			stepSize := ( (value at: 'stepSize') < 0 ifTrue: [0] ifFalse: [value at: 'stepSize'] ).
			endIndex := stepSize isZero ifTrue: [self model allRoots size]  ifFalse:   [ self model amountToFilterBy + stepSize ].
			self renderer scriptFor: self model glamourPresentation add: (
				(self renderer html jQuery expression:  ('#',self htmlId, ' > ul') ) 
					glamourTree appendRoots: [:aRenderer|
						self 
							renderRootNodesFrom: self model amountToFilterBy + 1 
							to:  ( endIndex  min: self model allRoots size  )
							on: aRenderer ] ).	
			stepSize isZero ifFalse: [self model stepSize: stepSize].
			self model amountToFilterBy: (stepSize isZero ifTrue: [0] ifFalse: [endIndex]).
			self model updateModelSelection.
			self updateSelectedNodes.
			self renderer updateScript: script ]! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 10/20/2010 21:19'!
onAppendURLWith: html
	^ html jQuery ajax 
		sglTreeCallbackAppendURL:  [ :value :aRenderer |
			|aNode|
			aNode := self nodeForId: (value at: 'id').
			aNode markChildrenAsRendered.
			self renderNodes: aNode contents asListFromLevel: aNode path size on: aRenderer ] ! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'cyrilledelaunay 7/26/2011 16:31'!
onClickActionForTag: aTag of: aNode with: html
	^ html jQuery ajax script: [:s | 
		aNode containerTree toggleFilteringByTag: aTag.
		s << ( html jQuery id: (self renderer uuidFor: aNode containerTree glamourPresentation ) )
			replaceWith: [ :aRenderer |
				self model markAllNodesAsNotRenderer.
				nodesId := Dictionary new.
				aRenderer render: self ] ] ! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'cyrilledelaunay 7/27/2011 12:19'!
onDoubleClickActionOn: aNode with: html

	^ html jQuery ajax script: [:s | 
		self model glamourPresentation strongSelection: aNode item.
		self renderer updateScript: s
			] ! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 10/19/2010 22:15'!
onExpandToggledActionForANodeWith: html
	^ html jQuery ajax 
		sglTreeCallbackToggleExpand: [ :event :script |
			|aNode|
			aNode := self nodeForId: (event at: 'node').
			aNode toggleExpansion.
			self renderer updateScript: script ]! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 10/21/2010 00:15'!
onSelectActionURLForANodeWith: html
	^ html jQuery ajax 
		sglTreeCallbackSelectURL:  [ :value :script |
			|nodes|
			nodes := ( (value at: 'selectedIds') contents findTokens: $, ) collect: [:each | 
				(self nodeForId: each) item].
			(self model glamourPresentation isMultiple not) 
				ifTrue: [self model explicitSelection: (nodes at: 1) ]
				ifFalse:  [self model explicitSelection: nodes].
			"(nodes size == 1) 
				ifTrue: [self explicitSelection: (nodes at: 1) ]
				ifFalse:  [self explicitSelection: nodes]."
			self updateSelectedNodes.
			self renderer updateScript: script ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/26/2011 16:43'!
renderContentOn: html
	self initializeModelSelection: html.
	(self widgetContainerWith: html)
		class: 'sgl-tree-presentation';
		id: self htmlId;
		with: [
			self renderInitialRootNodesOn: html ]
	! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/26/2011 16:44'!
renderInitialRootNodesOn: html
	|amountToFilterBy| 
	amountToFilterBy := self model amountToFilterBy.
	html unorderedList  
		id: html nextId;
		script: (self treeInitializationScriptWith: html);
		with: [ self renderRootNodesFrom: 1 to: ( amountToFilterBy isZero ifTrue: [self model roots size] ifFalse: [amountToFilterBy] ) on: html ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 10:50'!
renderNode: aNode fromLevel: level on: html
	|children|
	self associateNode: aNode withId: html nextId.
	children := aNode contents.
	
			html listItem  
			onDoubleClick: (self onDoubleClickActionOn: aNode with: html);
			id: (self idOfNode: aNode);
			"class: 'sgl-tree-node';"
			"class: 'sgl-tree-node-leaf' if: children size == 0;"
			"class: 'sgl-tree-node-opened' if: (children size > 0 and: [aNode expanded]);"
			class: 'sgl-tree-node-closed' if: (children size > 0 and: [aNode expanded not]);
			with: [
				self renderNodeTitleFor: aNode on: html.
				(children size > 0 and: [ aNode expanded ] ) ifTrue: [ 
					self renderNodes: children asListFromLevel: level+1 on: html.
					aNode markChildrenAsRendered ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 12:31'!
renderNodeTitleFor: aNode on: html
	(html div)
		script: (self fullTextCssScriptForNode: aNode With: html);
		with: [ 
			html span
				with: [ 
					(html span)
						script: (self textBackgroundColorScriptFor: aNode with: html);
						with: [ 
							1 to: aNode displayText size do: [ :tmpIndex | 
								(html span)
									script: (html jQuery this css: (aNode displayText cssDictionaryAt: tmpIndex));
									with: (aNode displayText at: tmpIndex) asString ] 
								].
					self renderTagsOf: aNode on: html
					] 
				]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 10/17/2010 21:32'!
renderNodes: nodes asListFromLevel: level on: html
	html unorderedList 
		id: html nextId;
		with: [ nodes do: [:each | 
			self renderNode: each fromLevel: level on: html ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 10/20/2010 20:44'!
renderRootNodesFrom: startIndex to: endIndex on: html
	|nodes|
	nodes := self model allRoots.
	(startIndex > 0 and: [endIndex > 0 and: [startIndex <= endIndex] ]) ifTrue: [
		( (startIndex min: self model allRoots size) to: (endIndex min: self model allRoots size) ) do: [ :each |   
			self renderNode: (nodes at: each)  fromLevel: 0 on: html ] ]! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 11:56'!
renderTag: aTag withFilter: aFilter for: aNode on: html
	html div
		class: 'glm-tree-tag ui-corner-top ui-corner-bottom';
		class: 'glm-tree-tag-selected' if: ( aNode containerTree tagsToFilterBy includes: aTag );
		onClick: (self onClickActionForTag: aTag of: aNode with: html);
		onClick: JQEvent new stopPropagation, JQEvent new preventDefault;
		with: aTag asString ! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'AndreiChis 7/27/2010 22:40'!
renderTagsOf: aNode on: html
	| tags tagsFilter |
	tags:= aNode containerTree glamourPresentation tagsFor: aNode item to: #show.
	tagsFilter := aNode containerTree glamourPresentation tagsFor: aNode item to: #filter.
	html div
		class: 'glm-tree-tags';
		with: [
			tags withIndexDo:[ :each :index | 
				self renderTag: each withFilter: (tagsFilter at: index ifAbsentPut:[ each ] ) for: aNode on: html ] ]! !

!SGLTreePresenter methodsFor: 'private' stamp: 'AndreiChis 10/22/2010 00:12'!
selectNodesScript
	^ (self renderer html jQuery expression:  ('#',self htmlId, ' > ul') ) 
		glamourTree 
			option: 'selectedNodes' put: self selectedIds;
			yourself 

	! !

!SGLTreePresenter methodsFor: 'private' stamp: 'AndreiChis 10/19/2010 19:00'!
selectedIds
	|ids|
	ids := OrderedCollection new.
	self model selection ifNotNil: [ self model selection selectedNodes do: [:node |
		(node isNil not and: [node shouldBeDisplayed]) ifTrue: [ 
			(self idOfNode: node)
				ifNil: [
					|path unrenderedNode|
					path := node path.
					unrenderedNode := path detect: [:each| each areChildrenRendered not].
					(path indexOf: unrenderedNode) to: path size - 1do: [:index| (path at: index) expanded: true].
					unrenderedNode expanded: true.
					self updateNodeContentScriptFor: unrenderedNode.
					self toggleNodeClassFor: unrenderedNode.
					unrenderedNode markChildrenAsRendered ].
			ids add: (self idOfNode: node) ] ] ].
	^ ids! !

!SGLTreePresenter methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/27/2011 12:30'!
textBackgroundColorScriptFor: aNode with: html
	^ html jQuery this
		css:
			((Dictionary new)
				at: 'background-color' put: (self model glamourPresentation textBackgroundColorFor: aNode item) glmAsHtmlColor;
				yourself)! !

!SGLTreePresenter methodsFor: 'private' stamp: 'AndreiChis 10/22/2010 00:12'!
toggleNodeClassFor: aNode
	self renderer scriptFor: self model glamourPresentation add: (
		(self renderer html jQuery expression:  ('#',self htmlId, ' > ul') ) 
			glamourTree  toggleExpand: (self idOfNode: aNode) andTriggerEventIf: false)! !

!SGLTreePresenter methodsFor: 'jQuery-scripts' stamp: 'AndreiChis 1/5/2011 22:53'!
treeInitializationScriptWith: html
	|tree|
	tree := html jQuery new glamourTree
		isMultiple: self model glamourPresentation isMultiple;
		selectedNodes: self selectedIds; 
		selectURL: (self onSelectActionURLForANodeWith: html);
		appendURL: (self onAppendURLWith: html);		
		onToggleExpand: (self onExpandToggledActionForANodeWith: html).
	tree useAppend
		stepSize:  (self model stepSize);
		maximumSize: self model allRoots size;
		appendRootsURL: (self onAppendRootsURLWith: html).
	^ tree! !

!SGLTreePresenter methodsFor: 'private' stamp: 'AndreiChis 10/22/2010 00:11'!
updateNodeContentScriptFor: aNode
	self renderer scriptFor: self model glamourPresentation add: (
		(self renderer html jQuery expression:  ('#',self htmlId, ' > ul') ) 
			glamourTree 
				appendSubtree: [:aRenderer | 
					self renderNodes: aNode contents asListFromLevel: aNode path size on: aRenderer] 
				to: ( (self idOfNode: aNode) ) )! !

!SGLTreePresenter methodsFor: 'callbacks' stamp: 'AndreiChis 10/19/2010 18:55'!
updateSelectedNodes
	self renderer 
		scriptFor: self model glamourPresentation 
		add: self selectNodesScript! !

!SGLTreePresenter methodsFor: 'callbacks' stamp: 'AndreiChis 7/30/2010 02:18'!
updateSelectionWithNode: aNode on: aScript
	self explicitSelection: aNode.
	self updateSelectedNodes.
	self renderer updateScript: aScript! !

!Color methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 13:12'!
glmAsHtmlColor

	self = Color transparent ifTrue: [^ 'transparent'].
	^ '#',self printHtmlString ! !

!Text methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:42'!
cssDictionary

	"for now we only check the first character text attributes that we will applied to the full text"
	^ self cssDictionaryAt: 1! !

!Text methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:29'!
cssDictionaryAt: anIndex

	"return the css dictionary for the character at anIndex"
	|tmpDictionary|
	tmpDictionary := Dictionary new.
	(self attributesAt: anIndex) do: [:aTextAttribute |
		tmpDictionary at: aTextAttribute cssPropertyAndValue key put: aTextAttribute cssPropertyAndValue value 
		].
	^ tmpDictionary
		! !

!Text methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:57'!
cssDictionaryForFullText

	"return a css dictionary for attributes that are applied for the full text"
	|tmpAttributes tmpDictionary|
	tmpDictionary := Dictionary new.
	tmpAttributes := (self attributesAt: 1) asOrderedCollection.
	1 to: self size do: [:tmpIndex |
		|tmpToRemove|
		tmpToRemove := OrderedCollection new.
		tmpAttributes do: [:aTextAttribute |
			((self attributesAt: tmpIndex) includes: aTextAttribute) 
				ifFalse: [tmpToRemove add: aTextAttribute]
			].
		tmpToRemove do: [:aTextAttribute |
			tmpAttributes remove: aTextAttribute
			] 
		].
	tmpAttributes do: [:aTextAttribute |
		tmpDictionary at: aTextAttribute cssPropertyAndValue key put: aTextAttribute cssPropertyAndValue value.
		].
	^ tmpDictionary! !

!TextAttribute methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 12:36'!
cssPropertyAndValue

	^ nil->nil! !

!TextEmphasis methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 12:13'!
cssPropertyAndValue

	| strm |
	emphasisCode = 1 ifTrue: [^ ('font-weight' -> 'bold') ].
	emphasisCode = 2 ifTrue: [^ ('font-style' -> 'italic') ].
	emphasisCode = 4 ifTrue: [^ ('text-decoration' -> 'underline')].
	emphasisCode = 16 ifTrue: [^ ('text-decoration' -> 'line-through')].
	^ (nil -> nil)! !

!TextColor methodsFor: '*glamour-seaside-rendering' stamp: 'cyrilledelaunay 7/21/2011 14:41'!
cssPropertyAndValue

	^ ('color' -> ( self color glmAsHtmlColor))! !

Object subclass: #SGLRenderer
	instanceVariableNames: 'component html uuid scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLRenderer classSide methodsFor: 'instance-creation' stamp: 'AndreiChis 2/17/2011 17:36'!
in: aComponent on: aCanvas
	^ self basicNew initializeIn: aComponent on: aCanvas! !

!SGLRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 8/5/2011 16:31'!
component

	^ component! !

!SGLRenderer methodsFor: 'accessing' stamp: 'AndreiChis 8/21/2010 00:48'!
html
	^ html! !

!SGLRenderer methodsFor: 'accessing' stamp: 'AndreiChis 2/17/2011 17:34'!
html: aCanvas
	html := aCanvas! !

!SGLRenderer methodsFor: 'initialization' stamp: 'AndreiChis 8/29/2010 17:42'!
initialize
	super initialize.
	uuid := IdentityDictionary new.
	scripts := GRSmallDictionary new! !

!SGLRenderer methodsFor: 'initialization' stamp: 'AndreiChis 2/17/2011 17:35'!
initializeIn: aComponent on: aCanvas
	self initialize.
	component := aComponent.
	html := aCanvas! !

!SGLRenderer methodsFor: 'rendering' stamp: 'lr 3/11/2009 11:20'!
render: aRenderable
	aRenderable renderGlamorouslyOn: self! !

!SGLRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 17:34'!
render: aRenderable on: aCanvas
	html := aCanvas.
	aRenderable renderGlamorouslyOn: self! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 17:39'!
renderAccordionCompositePresentation: aCompositePresentation
	html render: (SGLAccordionCompositePresenter for: aCompositePresentation from: self)! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'AndreiChis 8/30/2010 14:56'!
renderAccumulator: aBrowser
	html render: (SGLAccumulatorPresenter for: aBrowser from: self)! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/19/2010 20:49'!
renderActionListPresentation: anActionListPresentation 
	self flag: 'To implement'.
	self renderEmptyPresentation ! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 5/23/2011 16:34'!
renderDashboard: aBrowser
	html render: (SGLDashboardPresenter for: aBrowser from: self)
! !

!SGLRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/17/2011 17:20'!
renderDynamicPresentation: aPresentation
	html render: (SGLDynamicPresenter for: aPresentation from: self)! !

!SGLRenderer methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 16:57'!
renderEmptyPresentation
	self flag: 'to delete'.
	html div
		class: 'ui-widget';
		class: 'ui-widget-content';
		class: 'ui-corner-all';
		class: 'glm-empty-presentation'! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'AndreiChis 1/11/2011 16:03'!
renderExpander: aBrowser
	html render: (SGLExpanderPresenter for: aBrowser from: self)! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreHora 4/27/2011 11:51'!
renderEyeSeePresentation: aPresentation
	html render: (SGLEyeSeePresenter for: aPresentation from: self)! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'AndreiChis 8/30/2010 14:56'!
renderFinder: aBrowser
	html render: (SGLFinderPresenter for: aBrowser from: self)
	! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/19/2010 20:51'!
renderLabelPresentation: aLabelPresentation 
	self flag: 'To implement'.
	self renderEmptyPresentation
	! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 21:16'!
renderListPresentation: aPresentation
	| listPresenter |
	listPresenter := (SGLTreePresenter for: aPresentation from: self).
	listPresenter htmlId: (self uuidFor: aPresentation).
	html render: listPresenter! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'lr 5/6/2009 13:48'!
renderMagrittePresentation: aPresentation
	| form |
	form := aPresentation displayValue asComponent
		addValidatedForm;
		onAnswer: [ :answer | aPresentation selection: answer ].
	html div
		class: 'magritte';
		with: form! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 21:43'!
renderMondrianPresentation: aPresentation
	html render: (SGLMondrianPresenter for: aPresentation from: self)

	! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/19/2010 20:55'!
renderMorphPresentation: aMorphPresentation 
	self flag: 'To implement'.
	self renderEmptyPresentation.! !

!SGLRenderer methodsFor: 'rendering' stamp: 'AndreiChis 8/29/2010 20:52'!
renderPane: aPane
	html render: (SGLPanePresenter for: aPane from: self)! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 17:35'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	html render: (SGLStackedVerticallyCompositePresenter for: aCompositePresentation from: self)! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'AndreiChis 8/30/2010 14:56'!
renderStacker: aBrowser 
	html render: (SGLStackerPresenter for: aBrowser from: self)! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 03:34'!
renderTabbedCompositePresentation: aCompositePresentation
	html render: (SGLTabbedCompositePresenter for: aCompositePresentation from: self)! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/19/2010 20:49'!
renderTablePresentation: aPresentation
	self flag: 'To implement'.
	self renderEmptyPresentation.
! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'AndreiChis 8/30/2010 14:57'!
renderTabulator: aBrowser
	html render: (SGLTabulatorPresenter for: aBrowser from: self)
! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 03:12'!
renderTextPresentation: aTextPresentation
	| textPresenter |
	textPresenter := (SGLTextPresenter for: aTextPresentation from: self).
	textPresenter htmlId: (self uuidFor: aTextPresentation).
	html render: textPresenter
	
	! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 8/29/2010 21:18'!
renderTreePresentation: aPresentation
	| treePresenter |
	treePresenter := (SGLTreePresenter for: aPresentation from: self).
	treePresenter htmlId: (self uuidFor: aPresentation).
	treePresenter model shouldRootsExpand: aPresentation shouldRootsExpand.
	treePresenter model shouldAllExpand: aPresentation shouldAllExpand.
	html render: treePresenter! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 8/4/2011 15:19'!
renderValidator: aBrowser
	html render: (SGLValidatorPresenter for: aBrowser from: self)
! !

!SGLRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 8/4/2011 15:59'!
renderWizard: aBrowser
	html render: (SGLWizardPresenter for: aBrowser from: self)
! !

!SGLRenderer methodsFor: 'rendering presentations' stamp: 'lr 3/11/2009 11:25'!
renderWorkspacePresentation: aWorkspacePresentation
	self renderTextPresentation: aWorkspacePresentation! !

!SGLRenderer methodsFor: 'script' stamp: 'lr 8/25/2009 14:20'!
scriptFor: anObject add: aScript
	(scripts at: (self uuidFor: anObject) ifAbsentPut: [ JSScript new ]) , aScript! !

!SGLRenderer methodsFor: 'script' stamp: 'lr 8/25/2009 14:04'!
scriptFor: anObject put: aScript
	scripts at: (self uuidFor: anObject) put: aScript! !

!SGLRenderer methodsFor: 'script' stamp: 'AndreiChis 2/19/2011 21:29'!
updateScript: aScript
	aScript addAll: scripts values.
	"aScript add: (JSStream on: 'Glamour.resize()')."
	scripts := GRSmallDictionary new! !

!SGLRenderer methodsFor: 'script' stamp: 'lr 2/27/2009 14:54'!
uuidFor: anObject
	^ uuid at: anObject ifAbsentPut: [ html nextId ]! !

Object subclass: #SGLTreeNodeModel
	instanceVariableNames: 'item containerTree parentNode childrens expanded htmlId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTreeNodeModel classSide methodsFor: 'instance creation' stamp: 'AndreiChis 7/17/2010 17:01'!
with: anObject
	^ self new item: anObject ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:37'!
areChildrenRendered
	^ self containerTree isNodeRendered: self! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/22/2010 21:23'!
childrenItems
	^ childrens ifNil: [ 
		| allContents |
		allContents :=  (self containerTree glamourPresentation childrenValueOf: self item atLevel: self path size) ifNil: [OrderedCollection new].
		childrens := allContents collect: [ :d | 
			(self class with: d)
				parentNode: self;
				containerTree: self containerTree;
				yourself ] ].
	! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:05'!
containerTree
	^ containerTree! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:04'!
containerTree: anObject
	containerTree := anObject ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/22/2010 21:22'!
contents
	^ self childrenItems select: [ :each | each shouldBeDisplayed ] ! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 17:33'!
displayText
	^self containerTree glamourPresentation formatedDisplayValueOf: self item! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/31/2010 15:43'!
expandParentPath
	|path|
	path := self path.
	1 to: path size - 1 do: [:index| (path at: index) expanded: true ]! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 16:35'!
expanded
	^ expanded ifNil: [ expanded := self containerTree shouldAllExpand or: [ self path size == 1 and: [self containerTree shouldRootsExpand ] ] ]! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/18/2010 14:01'!
expanded: aBoolean
	expanded := aBoolean ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/29/2010 22:20'!
htmlId
	^ htmlId! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/2/2010 00:45'!
htmlIdIfNotNil: anObject
	htmlId ifNil: [htmlId := anObject]! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 17:02'!
item 
	^ item! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 17:02'!
item: anObject
	item := anObject ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:37'!
markChildrenAsRendered
	self containerTree markNodeAsRendered: self! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 17:40'!
parentNode
	^ parentNode ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 21:32'!
parentNode: aNode
	^ parentNode:= aNode ! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 19:49'!
path
	"Build the list of nodes to the root"
	
	|aCollection|
	aCollection := OrderedCollection new.
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [aCollection addAll: self parentNode path ] ].
	aCollection add: self.
	^ aCollection! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:37'!
rendered
	^ self containerTree isNodeRendered: self! !

!SGLTreeNodeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:37'!
rendered: aBoolean
	aBoolean 
		ifTrue: [ self containerTree markNodeAsRendered: self] 
		ifFalse: [ self containerTree markNodeAsUnRendered: self]! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/17/2010 22:45'!
shouldBeDisplayed
	^ self shouldBeDisplayedByTags! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:32'!
shouldBeDisplayedByTags
	| nodeTags |
	self containerTree tagsToFilterBy isEmpty ifTrue: [ ^ true ].
	self withContentsDo: [ :node | 
		nodeTags := self containerTree glamourPresentation tagsFor: node item to: #filter.
		(self containerTree tagsToFilterBy allSatisfy: [ :each | nodeTags includes: each ])
			ifTrue: [ ^ true ] ].
	^ false! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/30/2010 15:26'!
toggleExpansion
	self expanded 
		ifTrue: [self expanded: false] 
		ifFalse: [self expanded: true]! !

!SGLTreeNodeModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 7/18/2010 13:32'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

Object subclass: #SGLWidgetModel
	instanceVariableNames: 'glamourPresentation announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

SGLWidgetModel subclass: #SGLTextModel
	instanceVariableNames: 'text selectionInterval selectedText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTextModel classSide methodsFor: 'instance creation' stamp: 'AndreiChis 9/1/2010 23:25'!
for: aPresentation
	|model|
	model := self new glamourPresentation: aPresentation.
	
	"When the presenter changes, we want to update the glamour model"
	model announcer on: SGLTextPresenterTextChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation text: ann text ] ].
	model announcer on: SGLTextPresenterSelectedTextChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selectedText: ann selectedText ] ].
	model announcer on: SGLTextPresenterSelectionIntervalChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selectionInterval: ann selectionInterval ] ].
	^ model
! !

!SGLTextModel methodsFor: 'selection' stamp: 'AndreiChis 9/5/2010 22:47'!
addInitialSelections
	| selection |
	"We populate the text port"
	self text: self glamourPresentation displayValue.
	
	(self glamourPresentation selectionInterval isNil) 
		ifTrue: [
			selection := (self glamourPresentation selectedText = '') ifTrue: [nil] ifFalse: [self glamourPresentation selectedText].
			(selection isNil) 
				ifFalse:  [
					self selectedText: selection.
					self selectionInterval: (self intervalForSelection: selection) ] ] 
		ifFalse:  [
			selection := self selectionForInterval: self glamourPresentation selectionInterval.
			self selectionInterval:  self glamourPresentation selectionInterval.
			self selectedText: (selection isNil 
				ifTrue: [(self glamourPresentation selectedText = '') ifTrue: [nil] ifFalse: [self glamourPresentation selectedText]] 
				ifFalse: [selection]) ]
	
	! !

!SGLTextModel methodsFor: 'private' stamp: 'AndreiChis 8/28/2010 02:49'!
anounceSelectedTextChangedTo: aString
	self announcer announce: (
			SGLTextPresenterSelectedTextChanged  new 
				selectedText: aString;
				yourself)! !

!SGLTextModel methodsFor: 'private' stamp: 'AndreiChis 8/28/2010 02:50'!
anounceSelectionIntervalChangedTo: anInterval
	self announcer announce: (
			SGLTextPresenterSelectionIntervalChanged  new 
				selectionInterval: anInterval;
				yourself)! !

!SGLTextModel methodsFor: 'private' stamp: 'AndreiChis 8/28/2010 20:56'!
anounceTextChangedTo: aString
	self announcer announce: (
				SGLTextPresenterTextChanged  new 
					text: aString;
					yourself)! !

!SGLTextModel methodsFor: 'private' stamp: 'AndreiChis 9/5/2010 23:19'!
intervalForSelection: aString
	|index|
	self text ifNil: [^ self selectionInterval].
	index := aString 
		ifNil: [0] 
		ifNotNil: [self text findString: aString ].
	(index = 0)
		ifTrue: [^ nil] 
		ifFalse: [ ^ Interval from: index to: (index + aString size -1) ]! !

!SGLTextModel methodsFor: 'accessing' stamp: 'AndreiChis 8/23/2010 22:05'!
selectedText
	^ selectedText! !

!SGLTextModel methodsFor: 'callbacks' stamp: 'AndreiChis 9/2/2010 00:38'!
selectedText: aString
	self selectedText = aString 
		ifFalse: [
			selectedText := aString.
			self anounceSelectedTextChangedTo: aString ]! !

!SGLTextModel methodsFor: 'private' stamp: 'AndreiChis 9/5/2010 22:56'!
selectionForInterval: anInterval
	| from to interval |
	self text isNil ifTrue: [^self selectedText].
	anInterval isNil ifTrue: [^nil].
	(anInterval first > anInterval last )
		ifTrue: [ interval := Interval from: anInterval last to: anInterval first ]
		ifFalse: [ interval := anInterval ].
	(interval first > self text size or: [interval last < 1] ) ifTrue: [^nil].
	from := interval first max: 1.
	to :=  interval last min: self text size.
	^ self text copyFrom: from to: to
	! !

!SGLTextModel methodsFor: 'accessing' stamp: 'AndreiChis 8/23/2010 22:00'!
selectionInterval
	^ selectionInterval! !

!SGLTextModel methodsFor: 'callbacks' stamp: 'AndreiChis 9/2/2010 00:38'!
selectionInterval: anInterval
	self selectionInterval = anInterval
		ifFalse: [
			selectionInterval := anInterval.
			self anounceSelectionIntervalChangedTo: anInterval ]! !

!SGLTextModel methodsFor: 'callbacks' stamp: 'AndreiChis 9/2/2010 02:04'!
selectionInterval: anInterval withSelectedText: aString	
	(self selectionInterval = anInterval and: [ self selectedText = aString ]) 
		ifFalse: [
			selectionInterval := anInterval.
			selectedText := aString.
			self anounceSelectionIntervalChangedTo: anInterval.
			self anounceSelectedTextChangedTo: aString ]! !

!SGLTextModel methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 23:36'!
text
	^ text! !

!SGLTextModel methodsFor: 'callbacks' stamp: 'AndreiChis 8/28/2010 20:57'!
text: aString
	self text = aString 
		ifFalse: [
			text := aString.
			self anounceTextChangedTo: aString ]! !

SGLWidgetModel subclass: #SGLTreeModel
	instanceVariableNames: 'roots filteredRoots tagsToFilterBy amountToFilterBy stepSize shouldRootsExpand shouldAllExpand selection renderedNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Seaside-Rendering'!

!SGLTreeModel classSide methodsFor: 'instance creation' stamp: 'AndreiChis 10/28/2010 23:02'!
for: aPresentation
	|model|
	model := self new glamourPresentation: aPresentation.
	
	"When the morph changes, we want to update the glamour model"
	model announcer on: GLMTreeMorphSelectionChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selection: ann selectionValue.
			aPresentation selectionPath: ann selectionPathValue] ].
	"aPresentationModel announcer on: GLMTreeMorphStrongSelectionChanged do: [ :ann | 
		aPresentation strongSelection: ann strongSelectionValue ]."
	
	^model! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 10/20/2010 13:16'!
allRoots
	^ filteredRoots ifNil: [ self roots. filteredRoots ] ! !

!SGLTreeModel methodsFor: 'search and filtering' stamp: 'AndreiChis 10/26/2010 17:33'!
amountToFilterBy
	^ amountToFilterBy ifNil: [ amountToFilterBy := self stepSize]! !

!SGLTreeModel methodsFor: 'search and filtering' stamp: 'AndreiChis 10/20/2010 14:36'!
amountToFilterBy: anInteger
	amountToFilterBy := anInteger ! !

!SGLTreeModel methodsFor: 'callbacks' stamp: 'AndreiChis 7/28/2010 17:38'!
explicitSelection: anObject 
	"anObject is a domain object, not a Glamour related object"
	self glamourPresentation isMultiple 
		ifTrue: [ self explicitlySelectMultipleItems: anObject ]
		ifFalse: [ self explicitlySelectItem: anObject ]! !

!SGLTreeModel methodsFor: 'selection' stamp: 'cyrilledelaunay 7/27/2011 11:55'!
explicitlySelectItem: anObject 
	(self selectedItem isNil and: [ anObject isNil ]) ifTrue: [ ^ self ].
	anObject isNil ifTrue: [self selection: (MorphTreeMorphSingleSelection new selectedNodePath: nil)].
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			each item = anObject ifTrue: [
				"each expandParentPath."
				self selectNodePath: each path.
				^ self]
			].
		].! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 10/19/2010 17:56'!
explicitlySelectMultipleItems: aCollection
	| newSelection collection|
	aCollection isNil ifTrue: [^ self].
	collection := aCollection isCollection ifTrue: [aCollection] ifFalse: [aCollection asOrderedCollection ].
	newSelection := OrderedCollection new.
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			(collection includes: each item) ifTrue: [
				newSelection add: each path ]]].
	(newSelection isEmpty) ifFalse: [
		self selectAllNodePaths: newSelection ]! !

!SGLTreeModel methodsFor: 'initialization' stamp: 'AndreiChis 8/31/2010 03:17'!
initialize
	super initialize.
	renderedNodes := IdentityDictionary new! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:37'!
isNodeRendered: aNode
	^ renderedNodes at: aNode ifAbsentPut: [false]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:38'!
markAllNodesAsNotRenderer
	renderedNodes := IdentityDictionary new! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/31/2010 03:37'!
markNodeAsRendered: aNode
	renderedNodes at: aNode put: true! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2010 16:53'!
nodeModelFor: anObject
	^ (SGLTreeNodeModel with: anObject) containerTree: self; yourself! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 10/20/2010 11:41'!
roots
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filteredRoots ifNil: [filteredRoots := roots select: [ :each | each shouldBeDisplayed ] ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filteredRoots size]) and: [
			filteredRoots notEmpty]) ifTrue: [
		^ filteredRoots first: self amountToFilterBy ].
	^ filteredRoots! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 8/11/2010 18:12'!
roots: anObjectOrCollection
	anObjectOrCollection isCollection 
		ifTrue: [ |items|
			items := OrderedCollection new.
			anObjectOrCollection do: [:each | items add: (self nodeModelFor: each) ].
			roots := items ]
		ifFalse: [ roots := OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 10/19/2010 18:10'!
selectAllNodePaths: aCollectionOfNodePath
	(self shouldDeselect: aCollectionOfNodePath) ifTrue: [
		 self glamourPresentation allowsDeselection 
			ifTrue: [ 
				self selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: OrderedCollection new).
				^ self ]
			ifFalse: [
				^ self "If the selection is the same don't do anything"] ].
	self selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: aCollectionOfNodePath)! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/28/2010 23:14'!
selectNodePath: aNodePath
	(self shouldDeselect: aNodePath last)  ifTrue: [
			self glamourPresentation allowsDeselection 
				ifTrue: [ 
					self selection: (MorphTreeMorphSingleSelection new selectedNodePath: nil).
					^ self ]
				ifFalse: [
					^ self "If the selection is the same don't do anything"] ].
	self selection: (MorphTreeMorphSingleSelection new selectedNodePath: aNodePath)! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/28/2010 17:49'!
selectedItem
	^ self selectedNode ifNotNil: [:node | node item]! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/28/2010 17:48'!
selectedNode
	^ self selectedNodePath ifNotNil: [:path | path ifEmpty: [nil] ifNotEmpty: [path last]]! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/20/2010 21:29'!
selectedNodePath
	^ selection ifNotNil: [selection lastSelectedNodePath]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/20/2010 21:08'!
selection 
	^ selection! !

!SGLTreeModel methodsFor: 'callbacks' stamp: 'cyrilledelaunay 7/27/2011 11:39'!
selection: aSelection 
	self selection = aSelection ifTrue: [ ^ self ].
	selection := aSelection.
	self announcer announce: (
			GLMTreeMorphSelectionChanged new 
				selectionValue: (aSelection ifNotNil: [aSelection selectedItemOrItemsOrNil]);
				selectionPathValue: self selectionPathItems;
				yourself)! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/20/2010 21:19'!
selectionPathItems
	^ self selectedNodePath isNil ifTrue: [nil] ifFalse: [self selectedNodePath collect: [:each | each item]]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:57'!
shouldAllExpand
	^ shouldAllExpand ifNil: [shouldAllExpand := false]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:57'!
shouldAllExpand: anObject
	shouldAllExpand := anObject! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 7/28/2010 22:29'!
shouldDeselect: aNodeOrACollectionOfPaths
	self selection ifNil: [^ false].
	self glamourPresentation isMultiple 
		ifTrue: [
			^ self selection selectedNodePathList = aNodeOrACollectionOfPaths ] 
		ifFalse: [
			^ self selection lastSelectedNode = aNodeOrACollectionOfPaths ]! !

!SGLTreeModel methodsFor: 'search and filtering' stamp: 'AndreiChis 10/20/2010 11:35'!
shouldFilterByAmount
	^ self amountToFilterBy notNil and: [self amountToFilterBy isZero not]! !

!SGLTreeModel methodsFor: 'search and filtering' stamp: 'AndreiChis 7/17/2010 21:51'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:58'!
shouldRootsExpand
	^ shouldRootsExpand ifNil: [shouldRootsExpand := false]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 7/16/2010 14:57'!
shouldRootsExpand: anObject
	shouldRootsExpand := anObject! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 10/26/2010 17:33'!
stepSize
	^ stepSize ifNil: [ stepSize := self glamourPresentation amountToShow ifNil: [0] ]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 10/26/2010 17:32'!
stepSize: anObject
	stepSize := anObject! !

!SGLTreeModel methodsFor: 'search and filtering' stamp: 'AndreiChis 7/17/2010 21:49'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!SGLTreeModel methodsFor: 'search and filtering' stamp: 'AndreiChis 7/17/2010 21:51'!
toggleFilteringByTag: aTag 
	(self shouldFilterByTag: aTag) 
		ifTrue: [self tagsToFilterBy remove: aTag ]
		ifFalse: [self tagsToFilterBy add: aTag].
	self updateRoots ! !

!SGLTreeModel methodsFor: 'selection' stamp: 'AndreiChis 10/20/2010 21:08'!
updateModelSelection
	|aSelection|
	self announcer suspendAllWhile: [
		selection := nil.
		aSelection := self glamourPresentation selection.
		self explicitSelection: aSelection ]! !

!SGLTreeModel methodsFor: 'accessing' stamp: 'AndreiChis 10/20/2010 11:40'!
updateRoots
	"amountToShow := nil."
	filteredRoots := nil.
	self roots! !

!SGLWidgetModel methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 00:38'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!SGLWidgetModel methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2010 00:38'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!SGLWidgetModel methodsFor: 'accessing' stamp: 'AndreiChis 8/19/2010 23:36'!
glamourPresentation
	^ glamourPresentation! !

!SGLWidgetModel methodsFor: 'accessing' stamp: 'AndreiChis 8/19/2010 23:36'!
glamourPresentation: anObject
	glamourPresentation := anObject! !
